*$ CREATE FLUSCW.FOR
*COPY FLUSCW
*                                                                      *
*=== fluscw ===========================================================*
*                                                                      *
      DOUBLE PRECISION FUNCTION FLUSCW
     #(IJ,PLA,TXX,TYY,TZZ,WEE,XX,YY,ZZ,NREG,IOLREG,LLO,NSURF)
      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*
      INCLUDE '(BEAMCM)'
      INCLUDE '(SCOHLP)'
      INCLUDE '(TRACKR)'
      INCLUDE '(USRBDX)'
*
      PARAMETER ( NANGLE =  5 )
      PARAMETER ( NDEPTH = 25 )
      PARAMETER ( DDEPTH = 20.D+00 )
      DIMENSION ANGDEG (0:NANGLE), TANDEG (0:NANGLE)
      LOGICAL LFIRST, LSCHLP
      SAVE LFIRST, ANGDEG, TANDEG, ZREFER
      DATA LFIRST / .TRUE. /
      DATA ANGDEG / 0.D+00, 5.D+00, 10.D+00, 15.D+00, 20.D+00, 30.D+00 /
*
      IF ( LFIRST ) THEN
         LFIRST = .FALSE.
         DO 100 I = 0,NANGLE
            TANDEG (I) = TAN (DEGRAD * ANGDEG(I))
            TANDEG (I) = TANDEG (I)**2
  100    CONTINUE
         ZREFER = - ZBEAM - 100.D+00
         NHELP  = NUSRBX / NDEPTH
         MHELP  = NHELP  / NANGLE
         IF ( MHELP * NANGLE * NDEPTH .NE. NUSRBX )
     &      STOP 'FLUARLW_NUSRBX'
         DO 400 IZ = 1, NDEPTH
            ZFRTAR = DDEPTH * IZ + ZREFER
            ZFRTAR = ZFRTAR * ZFRTAR
            IZOFST = ( IZ - 1 ) * MHELP * NANGLE
            DO 300 IT = 1, MHELP
               IHOFST = ( IT - 1 ) * NANGLE
               DO 200 IA = 1, NANGLE
                  IUX    = IZOFST + IHOFST + IA
                  IF ( IUX .LE. 0 .OR. IUX .GT. NUSRBX ) STOP 'IUX'
                  AUSHLP = PIPIPI * ZFRTAR * ( TANDEG (IA)
     &                   - TANDEG (IA-1) )
                  AUSBDX (IUX) = AUSHLP
  200          CONTINUE
  300       CONTINUE
  400    CONTINUE
         DO 500 IUX = 1, NUSRBX
            IF ( ABS (AUSBDX (IUX)-ONEONE) .LT. ANGLGB ) THEN
               WRITE (LUNOUT,*)' *** IUX,AUSBDX',IUX,AUSBDX(IUX)
               STOP 'AUSBDX'
            END IF
  500    CONTINUE
         WRITE (LUNOUT,*)' *** Zrefer,Mhelp',ZREFER,MHELP
      END IF
      LSCZER = .FALSE.
      FLUSCW = ONEONE
      IF ( ISCRNG .EQ. 1 ) THEN
         LSCHLP = NREG .EQ. NR1USX (JSCRNG) .OR.
     &            NREG .EQ. NR2USX (JSCRNG)
         IF ( LSCHLP ) THEN
            LSCHLP = IOLREG .EQ. NR1USX (JSCRNG) .OR.
     &               IOLREG .EQ. NR2USX (JSCRNG)
            IF ( .NOT. LSCHLP ) THEN
               LSCZER = .TRUE.
               RETURN
            END IF
         ELSE
            LSCZER = .TRUE.
            RETURN
         END IF
         LSCRNG = MOD ( JSCRNG-1, 5 ) + 1
         ZFRTAR = ZZ + ZREFER
         ZFRTAR = ZFRTAR**2
*        IF ( ABS (AUSBDX (JSCRNG)-ONEONE) .LT. ANGLGB ) THEN
*           AUSHLP = PIPIPI * ZFRTAR * ( TANDEG (LSCRNG)
*    &             - TANDEG (LSCRNG-1) )
*           AUSBDX (JSCRNG) = AUSHLP
*        END IF
         TANHLP = ( XX**2 + YY**2 ) / ZFRTAR
         LSCZER = TANHLP .LT. TANDEG (LSCRNG-1) .OR. TANHLP .GE.
     &            TANDEG (LSCRNG)
      END IF
      RETURN
      END

